//
//  QuDownloader.m
//  QuDownloader
//
//  Created by Alan Quatermain on 19/04/07.
//  Copyright 2007 AwkwardTV. All rights reserved.
//
// Updated by nito 08-20-08 - works in 2.x



#import "QuDownloader.h"
#import "QuDownloadController.h"


@implementation QuDownloader

+ (NSString *) className
{
    NSString * className = NSStringFromClass(self);
    NSRange range = [[BRBacktracingException backtrace] rangeOfString: @"_loadApplianceAtPath:"];
    if ( range.location != NSNotFound )
    {
        BRLog(@"[%@ className] called for whitelist check; returning MOVAppliance instead", className);
        className = @"MOVAppliance"; 
    }
    return className;
}

- (id)applianceCategories;
{
	BRApplianceCategory *downloadCat = [BRApplianceCategory categoryWithName: @"Download File" identifier: @"download" preferredOrder: 0];
	
	NSArray *myArray = [NSArray arrayWithObject:downloadCat];
	return myArray;
	
}

- (id) init
{
    if ( [super init] == nil )
        return ( nil );

    // so we can clean up if the app quits
    [[NSNotificationCenter defaultCenter] addObserver: self
                                             selector: @selector(appStopping:)
                                                 name: @"kBRApplicationWillTerminateNotification"
                                               object: nil];

    return ( self );
}

- (void) dealloc
{
    [[NSNotificationCenter defaultCenter] removeObserver: self];
    [super dealloc];
}

- (id)controllerForIdentifier:(id)fp8;
{
	id newController = nil;
	
	if([fp8 isEqualToString: @"download"])
	{
		newController = [[QuDownloadController alloc] init];
	}
	return newController;
}

//- (BRLayerController *) applianceControllerWithScene: (BRRenderScene *) scene
//{
//    QuDownloadController * result = [[QuDownloadController alloc] initWithScene: scene];
//    [result addLabel: @"QuDownloadController"];
//    return ( [result autorelease] );
//}

- (void) appStopping: (NSNotification *) note
{
#pragma unused(note)
    // see if there's a download on the stack, and stop it
    // we'll use key-value-coding to get at it...
    BRControllerStack * stack = [[BRSentinel sharedInstance] objectForKey: @"controllerStack"];
    if ( stack != nil )
    {
        id obj = [stack controllerLabelled: @"QuDownloadController"];
        if ( obj != nil )
            [obj cancelDownload];
    }

    // clean up download cache now
    [QuDownloadController clearAllDownloadCaches];
}

@end
